#
# <URL:http://www.din.or.jp/~ohzaki/perl.htm#File_Lock> ˤ
# ˤ륳ɤ򸵤RubyΤǤܤˤĤƤϾ嵭
# Ȥˤ뵭ҤͤˤʤȻפޤΥɤθȤʤä
# Υɤϡѡ¤ϼͳפȤƤޤΤᤳΥ
# Ρѡ¤פּͳפȤޤޤRubyǤˤĤƤ۾
# RubyΤ˽ऺ뤳ȤȤޤ
#
# Copyright (C) 1999-2001 OHZAKI Hiroki. All rights reserved.
# Copyright (C) 2001 akira yamada <akira@ruby-lang.org>. All rights reserved.
# You can redistribute it and/or modify it under the same term as Ruby.
#

class MyLock
  class MyLockError < StandardError; end
  class LockError   < MyLockError; end
  class UnLockError < MyLockError; end

  def self.lock(basedir, basename, timeout = 60, maxtry = 10)
    l = new(basedir, basename, timeout, maxtry)
    if block_given?
      l.lock {yield}
    else
      l.lock
      l
    end
  end

  def initialize(basedir, basename, timeout = 60, maxtry = 10)
    @basedir  = basedir
    @basename = basename
    @timeout  = timeout
    @maxtry   = maxtry

    @basefile = File.join(@basedir, @basename)
    @lockfile = nil
  end

  def lock
    if r = lock_ex
      if block_given?
	begin
	  r = yield
	ensure
	  unlock
	end
      end
    else
      raise LockError
    end

    r
  end

  def unlock
    return false unless @lockfile
    begin
      File.rename(@lockfile, @basefile)
    rescue Errno::ENOENT
      raise UnLockError
    end
  end

  def lock_ex
    @maxtry.times do
      @lockfile = @basefile + Time.now.to_i.to_s
      begin
	File.rename(@basefile, @lockfile)
	return true
      rescue Errno::ENOENT
      end
    end

    Dir.foreach(@basedir) do |file|
      if /^#{Regexp.quote(@basename)}(\d+)$/ =~ file
	if Time.now - $1.to_i > @timeout
	  @lockfile = @basefile + Time.now.to_i.to_s
	  begin
	    File.rename(File.join(@basedir, file), @lockfile)
	    return true
	  rescue Errno::ENOENT
	  end
	end
	break
      end
    end

    @lockfiel = nil
    false
  end
  private :lock_ex

  def inspect
    '#<%s:0x%x>'%[self.type, self.id]
  end
end
